unit SevenZip32;

interface

uses
	Windows, Messages, SysUtils,
	UnifyArc;

const
	SEVENZIP32_VERSION = 2302301;

//* LHA.DLL݊API */
function _SevenZip(const Wnd:HWND; CmdLine: LPCSTR; Output: LPSTR; const Size: DWORD): Integer; stdcall;
function _SevenZipGetVersion: WORD; stdcall;
(* 蔲
function SevenZipGetCursorMode: BOOL; stdcall;
function SevenZipSetCursorMode(const CursorMode: BOOL):	BOOL  ;stdcall;
function SevenZipGetBackGroundMode():	BOOL  ;stdcall;
function SevenZipSetBackGroundMode(const BackGroundMode: BOOL):	BOOL  ;stdcall;
function SevenZipGetCursorInterval():	WORD  ;stdcall;
function SevenZipSetCursorInterval(const Interval: WORD):	BOOL  ;stdcall;
function SevenZipGetRunning: BOOL; stdcall;
*)

var
	SevenZip: function(const Wnd: HWND; CmdLine: LPCSTR; Output: LPSTR; const Size: DWORD): Integer; stdcall = _SevenZip;
	SevenZipGetVersion: function: WORD; stdcall = _SevenZipGetVersion;

//* A[JCoAPI */
function _SevenZipConfigDialog(const Wnd: HWND; OptionBuffer: LPSTR; const Mode: Integer): BOOL; stdcall;
function _SevenZipCheckArchive(FileName: LPCSTR; const Mode: Integer): BOOL; stdcall;
function _SevenZipGetFileCount(ArcFile: LPCSTR): Integer; stdcall;
function _SevenZipQueryFunctionList(const Func: Integer): BOOL; stdcall;

var
	SevenZipConfigDialog: function(const Wnd: HWND; OptionBuffer: LPSTR; const Mode: Integer): BOOL; stdcall = _SevenZipConfigDialog;
	SevenZipCheckArchive: function(FileName: LPCSTR; const Mode: Integer): BOOL; stdcall = _SevenZipCheckArchive;
	SevenZipGetFileCount: function(ArcFile: LPCSTR): Integer; stdcall = _SevenZipGetFileCount;
	SevenZipQueryFunctionList: function(const Func: Integer): BOOL; stdcall = _SevenZipQueryFunctionList;

//* OpenArchivenAPI */
function _SevenZipOpenArchive(const Wnd: HWND; FileName: LPCSTR; const Mode: DWORD): HARC; stdcall;
function _SevenZipCloseArchive(Arc: HARC): Integer; stdcall;
function _SevenZipFindFirst(Arc: HARC; WildName: LPCSTR; var SubInfo: TINDIVIDUALINFO): Integer; stdcall;
function _SevenZipFindNext(Arc: HARC; var SubInfo: TINDIVIDUALINFO): Integer; stdcall;
(*蔲
function SevenZipGetArcFileName(HARC _harc, LPSTR _lpBuffer, const Integer _nSize):	Integer   ;stdcall;
function SevenZipGetArcFileSize(HARC _harc):	DWORD ;stdcall;
function SevenZipGetArcOriginalSize(HARC _harc):	DWORD ;stdcall;
function SevenZipGetArcCompressedSize(HARC _harc):	DWORD ;stdcall;
function SevenZipGetArcRatio(HARC _harc):	WORD  ;stdcall;
function SevenZipGetArcDate(HARC _harc):	WORD  ;stdcall;
function SevenZipGetArcTime(HARC _harc):	WORD  ;stdcall;
function SevenZipGetArcOSType(HARC _harc):	UINT  ;stdcall;
function SevenZipIsSFXFile(HARC _harc):	Integer   ;stdcall;
function SevenZipGetFileName(HARC _harc, LPSTR _lpBuffer, const Integer _nSize):	Integer   ;stdcall;
function SevenZipGetOriginalSize(HARC _harc):	DWORD ;stdcall;
function SevenZipGetCompressedSize(HARC _harc):	DWORD ;stdcall;
function SevenZipGetRatio(HARC _harc):	WORD  ;stdcall;
function SevenZipGetDate(HARC _harc):	WORD  ;stdcall;
function SevenZipGetTime(HARC _harc):	WORD  ;stdcall;
function SevenZipGetCRC(HARC _harc):	DWORD ;stdcall;
*)
function _SevenZipGetAttribute(Arc: HARC): Integer; stdcall;
(*蔲
function SevenZipGetOSType(HARC _harc):	UINT  ;stdcall;
function SevenZipGetMethod(HARC _harc, LPSTR _lpBuffer, const Integer _nSize):	Integer   ;stdcall;
*)
function _SevenZipGetWriteTime(Arc: HARC): DWORD; stdcall;
function _SevenZipGetWriteTimeEx(Arc: HARC; var LastWriteTime: FILETIME): BOOL; stdcall;
(*蔲
function SevenZipGetArcCreateTimeEx(HARC _harc, FILETIME *_lpftCreationTime):	BOOL  ;stdcall;
function SevenZipGetArcAccessTimeEx(HARC _harc, FILETIME *_lpftLastAccessTime):	BOOL  ;stdcall;
function SevenZipGetArcWriteTimeEx(HARC _harc, FILETIME *_lpftLastWriteTime):	BOOL  ;stdcall;
function SevenZipGetArcFileSizeEx(HARC _harc, ULHA_INT64 *_lpllSize):	BOOL  ;stdcall;
function SevenZipGetArcOriginalSizeEx(HARC _harc, ULHA_INT64 *_lpllSize):	BOOL  ;stdcall;
function SevenZipGetArcCompressedSizeEx(HARC _harc, ULHA_INT64 *_lpllSize):	BOOL  ;stdcall;
function SevenZipGetOriginalSizeEx(HARC _harc, ULHA_INT64 *_lpllSize):	BOOL  ;stdcall;
function SevenZipGetCompressedSizeEx(HARC _harc, ULHA_INT64 *_lpllSize):	BOOL  ;stdcall;
*)

var
	SevenZipOpenArchive: function(const Wnd: HWND; FileName: LPCSTR; const Mode: DWORD): HARC; stdcall = _SevenZipOpenArchive;
	SevenZipCloseArchive: function(Arc: HARC): Integer; stdcall = _SevenZipCloseArchive;
	SevenZipFindFirst: function(Arc: HARC; WildName: LPCSTR; var SubInfo: TINDIVIDUALINFO): Integer; stdcall = _SevenZipFindFirst;
	SevenZipFindNext: function(Arc: HARC; var SubInfo: TINDIVIDUALINFO): Integer; stdcall = _SevenZipFindNext;
	SevenZipGetAttribute: function(Arc: HARC): Integer; stdcall = _SevenZipGetAttribute;
	SevenZipGetWriteTime: function(Arc: HARC): DWORD; stdcall = _SevenZipGetWriteTime;
	SevenZipGetWriteTimeEx: function(Arc: HARC; var LastWriteTime: FILETIME): BOOL; stdcall = _SevenZipGetWriteTimeEx;

//* SetOwnerWindownAPI */
function _SevenZipSetOwnerWindow(Wnd: HWND): BOOL; stdcall;
function _SevenZipClearOwnerWindow: BOOL; stdcall;
function _SevenZipSetOwnerWindowEx(Wnd: HWND; ArcProc: PARCHIVERPROC): BOOL; stdcall;
function _SevenZipKillOwnerWindowEx(Wnd: HWND): BOOL; stdcall;

var
	SevenZipSetOwnerWindow: function(Wnd: HWND): BOOL; stdcall = _SevenZipSetOwnerWindow;
	SevenZipClearOwnerWindow: function: BOOL; stdcall = _SevenZipClearOwnerWindow;
	SevenZipSetOwnerWindowEx: function(Wnd: HWND; ArcProc: PARCHIVERPROC): BOOL; stdcall = _SevenZipSetOwnerWindowEx;
	SevenZipKillOwnerWindowEx: function(Wnd: HWND): BOOL; stdcall = _SevenZipKillOwnerWindowEx;

//* 7-zip32.dllƎAPI */
function _SevenZipGetSubVersion: WORD; stdcall;
function _SevenZipGetArchiveType(FileName: LPCSTR): Integer; stdcall;

var
	SevenZipGetSubVersion: function: WORD; stdcall = _SevenZipGetSubVersion;
	SevenZipGetArchiveType: function(FileName: LPCSTR): Integer; stdcall = _SevenZipGetArchiveType;

const
	// Ɍ`
	ARCHIVETYPE_ZIP	= 1;
	ARCHIVETYPE_7Z  = 2;

type
	ESevenZipError = class(EArchiverError);

const
	SevenZip32Dll = '7-zip32.dll';

function SevenZipEnabled: Boolean;

implementation

type
	EError = ESevenZipError;

const
	ArchiverDll = SevenZip32Dll;

var
	Module: THandle;

function SevenZipEnabled: Boolean;
begin
	if Module = 0 then
		Module := SafeLoadLibrary(ArchiverDll);

	Result := Module <> 0;
end;

function GetProcAddress(ProcName: PChar): Pointer;
begin
	if Module = 0 then
	begin
		Module:= SafeLoadLibrary(ArchiverDll);
		if Module = 0 then
			raise EError.CreateFmt(SFaultLoad, [ArchiverDll]);
	end;
	Result := Windows.GetProcAddress(Module, ProcName);
	if Result = nil then
		raise EError.CreateFmt(SNoExistProc, [ArchiverDll, ProcName]);
end;

function _SevenZip(const Wnd:HWND;CmdLine: LPCSTR;Output: LPSTR; const Size:DWORD):	Integer   ;stdcall;
begin
	@SevenZip := GetProcAddress('SevenZip');
	Result := SevenZip(Wnd, CmdLine, Output, Size)
end;

function _SevenZipGetVersion: WORD; stdcall;
begin
	@SevenZipGetVersion := GetProcAddress('SevenZipGetVersion');
	Result := SevenZipGetVersion
end;

function _SevenZipCheckArchive(FileName: LPCSTR; const Mode: Integer): BOOL; stdcall;
begin
	@SevenZipCheckArchive := GetProcAddress('SevenZipCheckArchive');
	Result := SevenZipCheckArchive(FileName, Mode)
end;

function _SevenZipGetFileCount(ArcFile: LPCSTR): Integer; stdcall;
begin
	@SevenZipGetFileCount := GetProcAddress('SevenZipGetFileCount');
	Result := SevenZipGetFileCount(ArcFile)
end;

function _SevenZipConfigDialog(const Wnd: HWND; OptionBuffer: LPSTR; const Mode: Integer): BOOL; stdcall;
begin
	@SevenZipConfigDialog := GetProcAddress('SevenZipConfigDialog');
	Result := SevenZipConfigDialog(Wnd, OptionBuffer, Mode)
end;

function _SevenZipQueryFunctionList(const Func: Integer): BOOL; stdcall;
begin
	@SevenZipQueryFunctionList := GetProcAddress('SevenZipQueryFunctionList');
	Result := SevenZipQueryFunctionList(Func)
end;

function _SevenZipOpenArchive(const Wnd: HWND; FileName: LPCSTR; const Mode: DWORD): HARC; stdcall;
begin
	@SevenZipOpenArchive := GetProcAddress('SevenZipOpenArchive');
	Result := SevenZipOpenArchive(Wnd, FileName, Mode)
end;

function _SevenZipCloseArchive(Arc: HARC): Integer; stdcall;
begin
	@SevenZipCloseArchive := GetProcAddress('SevenZipCloseArchive');
	Result := SevenZipCloseArchive(Arc)
end;

function _SevenZipFindFirst(Arc: HARC; WildName: LPCSTR; var SubInfo: TINDIVIDUALINFO): Integer; stdcall;
begin
	@SevenZipFindFirst := GetProcAddress('SevenZipFindFirst');
	Result := SevenZipFindFirst(Arc, WildName, SubInfo)
end;

function _SevenZipFindNext(Arc: HARC; var SubInfo: TINDIVIDUALINFO): Integer; stdcall;
begin
	@SevenZipFindNext := GetProcAddress('SevenZipFindNext');
	Result := SevenZipFindNext(Arc, SubInfo)
end;

function _SevenZipGetWriteTime(Arc: HARC): DWORD; stdcall;
begin
	@SevenZipGetWriteTime := GetProcAddress('SevenZipGetWriteTime');
	Result := SevenZipGetWriteTime(Arc)
end;

function _SevenZipGetWriteTimeEx(Arc: HARC; var LastWriteTime: TFILETIME): BOOL; stdcall;
begin
	@SevenZipGetWriteTimeEx := GetProcAddress('SevenZipGetWriteTimeEx');
	Result := SevenZipGetWriteTimeEx(Arc, LastWriteTime)
end;

function _SevenZipGetAttribute(Arc: HARC): Integer; stdcall;
begin
	@SevenZipGetAttribute := GetProcAddress('SevenZipGetAttribute');
	Result := SevenZipGetAttribute(Arc)
end;

function _SevenZipSetOwnerWindow(Wnd: HWND): BOOL; stdcall;
begin
	@SevenZipSetOwnerWindow := GetProcAddress('SevenZipSetOwnerWindow');
	Result := SevenZipSetOwnerWindow(Wnd)
end;

function _SevenZipClearOwnerWindow: BOOL; stdcall;
begin
	@SevenZipClearOwnerWindow := GetProcAddress('SevenZipClearOwnerWindow:');
	Result := SevenZipClearOwnerWindow
end;

function _SevenZipSetOwnerWindowEx(Wnd: HWND; ArcProc: PARCHIVERPROC): BOOL; stdcall;
begin
	@SevenZipSetOwnerWindowEx := GetProcAddress('SevenZipSetOwnerWindowEx');
	Result := SevenZipSetOwnerWindowEx(Wnd, ArcProc)
end;

function _SevenZipKillOwnerWindowEx(Wnd: HWND): BOOL; stdcall;
begin
	@SevenZipKillOwnerWindowEx := GetProcAddress('SevenZipKillOwnerWindowEx');
	Result := SevenZipKillOwnerWindowEx(Wnd)
end;

function _SevenZipGetSubVersion: WORD; stdcall;
begin
	@SevenZipCheckArchive := GetProcAddress('SevenZipGetSubVersion');
	Result := SevenZipGetSubVersion
end;

function _SevenZipGetArchiveType(FileName: LPCSTR): Integer; stdcall;
begin
	@SevenZipGetArchiveType := GetProcAddress('SevenZipGetArchiveType');
	Result := SevenZipGetArchiveType(FileName)
end;

initialization

finalization

	if Module <> 0 then FreeLibrary(Module)

end.
